#property copyright "mladen"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrDeepSkyBlue
#property indicator_color5  clrSandyBrown
#property indicator_color6  clrSandyBrown
#property indicator_width1  2
#property indicator_width2  2
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property strict

//
//
//
//
//

extern int     BreakOutChannelLength =   20; // Break-out channel period
extern int     AverageLength         =   30; // Average period
extern double  AtrMultiplier         =    1; // ATR multiplier
extern int     AtrShortTerm          =   10; // Short term ATR period
extern int     AtrLongTerm           =  200; // Long term ATR period
extern double  Nla0                  =    1; // Non-linear a0 
extern double  Nla1                  =    1; // Non-linear a1 
extern double  Nla2                  = 0.02; // Non-linear a2 
extern double  Nlb0                  =    1; // Non-linear b0 
extern double  Nlb1                  =    1; // Non-linear b1 
extern double  Nlb2                  = 0.02; // Non-linear b2 


double sigu[],sigd[],siglu1[],sigld1[],siglu2[],sigld2[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,sigu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,sigd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,siglu1);
   SetIndexBuffer(3,siglu2);
   SetIndexBuffer(4,sigld1);
   SetIndexBuffer(5,sigld2);
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//



int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-2);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      double ATRst    = iATR(NULL,0,AtrShortTerm,i);
      double ATRlt    = iATR(NULL,0,AtrLongTerm,i);
      bool   EntLong  = (Close[i] > iMA(NULL,0,AverageLength,0,MODE_SMA,PRICE_CLOSE,i)) && (Close[i] > High[iHighest(NULL,0,MODE_HIGH,BreakOutChannelLength,i+1)] + AtrMultiplier*ATRst);
      bool   EntShort = (Close[i] < iMA(NULL,0,AverageLength,0,MODE_SMA,PRICE_CLOSE,i)) && (Close[i] < Low [iLowest (NULL,0,MODE_LOW ,BreakOutChannelLength,i+1)] - AtrMultiplier*ATRst);
      if (ATRlt==0) continue;
      double ExitSz1  = ATRlt * (Nla0 + Nla1 * (ATRst/ATRlt) + Nla2 * MathPow((ATRst/ATRlt), 2));
      double ExitSz2  = ATRlt * (Nlb0 + Nlb1 * (ATRst/ATRlt) + Nlb2 * MathPow((ATRst/ATRlt), 2));
      
             sigu[i]  = EMPTY_VALUE;
             sigd[i]  = EMPTY_VALUE;
             if (EntLong)  { sigu[i] = High[i]; sigd[i]=Low[i]; }
             if (EntShort) { sigd[i] = High[i]; sigu[i]=Low[i]; }
             siglu1[i] = Open[i]+ExitSz1;
             siglu2[i] = Open[i]+ExitSz2;
             sigld1[i] = Open[i]-ExitSz1;
             sigld2[i] = Open[i]-ExitSz2;
   }      
   return(0);
}

/*
Inputs: EntFr   (1),    { Fraction of ATR for entry }
         NChan   (20),   { Length of channel for breakout }
         NMA     (30),   { Length of moving average }
         NATRst  (10),   { Length of ATR, short-term }
         NATRlt  (200),  { Length of ATR, long-term }
         NBExit  (20),   { Number of bars from entry to exit }
         a0      (1),    { constants for nonlinear exits }
         a1      (1), 
         a2      (0.02),
         b0      (1),
         b1      (1),
         b2      (0.02);

 Var:    EntLong (FALSE),{ Flag for entering long next bar }
         EntShort(FALSE),{ Flag for entering short next bar }
         ATRst   (0),    { Average true range, short-term }
         ATRlt   (0),    { Average true range, long-term }
         ExitSz1 (0),    { Size in points of exit }
         ExitSz2 (0);    { Size in points of exit }
         
 { Entry conditions }
 ATRst = Average(TrueRange, NATRst);
 ATRlt = Average(TrueRange, NATRlt);
 EntLong = C > Average(C, NMA) and C > (Highest(H, NChan)[1] + EntFr * ATRst);
 EntShort = C < Average(C, NMA) and C < (Lowest(L, NChan)[1] - EntFr * ATRst);

 { Place trades }
 If EntLong then
    Buy next bar at market
 Else If EntShort then
    Sell short next bar at market;

 { Exit orders }
 ExitSz1 = ATRlt * (a0 + a1 * (ATRst/ATRlt) + a2 * power((ATRst/ATRlt), 2));
 ExitSz2 = ATRlt * (b0 + b1 * (ATRst/ATRlt) + b2 * power((ATRst/ATRlt), 2));
 If MarketPosition > 0 then Begin
 
    { Time exit: bars from entry }
    If BarsSinceEntry = NBExit then
       Sell("NBar-L") this bar on close;
   
    { Money management stop }
    {Sell("MM-L") next bar at EntryPrice - ExitSz1 stop;}

    { Target exit }
    Sell("Targ-L") next bar at EntryPrice + ExitSz2 limit;

 End
 Else If MarketPosition < 0 then Begin
 	
    { Time exit: bars from entry }
    If BarsSinceEntry = NBExit then
       Buy to cover("NBar-S") this bar on close;
   
    { Money management stop }
    {Buy to cover("MM-S") next bar at EntryPrice + ExitSz1 stop;}

    { Target exit }
    Buy to cover("Targ-S") next bar at EntryPrice - ExitSz2 limit;

 End;
*/